<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppClassIncludeClassDeclaration xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassIncludeClassDeclaration.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend;
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.utils.CppClassUtils;
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.utils.CppGenUtils;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassIncludeDeclaration;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.CppRoot;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.ExternLibrary;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.External;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.NoCodeGen;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DataType;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Functions.Function1;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.IterableExtensions;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment"> * @author Önder GÜRCAN (onder.gurcan@cea.fr)</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassIncludeClassDeclaration.html">CppClassIncludeClassDeclaration</a> {
<a class="jxr_linenumber" name="L28" href="#L28">28</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String cppOwnerPackageIncludePath(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Package pkg) {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>      <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>      <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(pkg, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L31" href="#L31">31</a>      <strong class="jxr_keyword">if</strong> (!_notEquals) {
<a class="jxr_linenumber" name="L32" href="#L32">32</a>        _and = false;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L34" href="#L34">34</a>        <strong class="jxr_keyword">boolean</strong> _hasStereotype = GenUtils.hasStereotype(pkg, CppRoot.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L35" href="#L35">35</a>        <strong class="jxr_keyword">boolean</strong> _not = (!_hasStereotype);
<a class="jxr_linenumber" name="L36" href="#L36">36</a>        _and = _not;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>      }
<a class="jxr_linenumber" name="L38" href="#L38">38</a>      <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L39" href="#L39">39</a>        String _fullPath = GenUtils.getFullPath(pkg);
<a class="jxr_linenumber" name="L40" href="#L40">40</a>        String _plus = (_fullPath + <span class="jxr_string">"/Pkg_"</span>);
<a class="jxr_linenumber" name="L41" href="#L41">41</a>        String _name = pkg.getName();
<a class="jxr_linenumber" name="L42" href="#L42">42</a>        String _plus_1 = (_plus + _name);
<a class="jxr_linenumber" name="L43" href="#L43">43</a>        <strong class="jxr_keyword">return</strong> (_plus_1 + <span class="jxr_string">".h"</span>);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>        <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      }
<a class="jxr_linenumber" name="L47" href="#L47">47</a>    }
<a class="jxr_linenumber" name="L48" href="#L48">48</a>    
<a class="jxr_linenumber" name="L49" href="#L49">49</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Iterable&lt;String&gt; CppClassAllIncludesDeclarationBody(<strong class="jxr_keyword">final</strong> Classifier classifier) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>      EList&lt;Classifier&gt; _includedImplementationClassifiers = CppClassUtils.includedImplementationClassifiers(classifier);
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      <strong class="jxr_keyword">return</strong> CppClassIncludeClassDeclaration.cppClassAllIncludes(classifier, _includedImplementationClassifiers);
<a class="jxr_linenumber" name="L52" href="#L52">52</a>    }
<a class="jxr_linenumber" name="L53" href="#L53">53</a>    
<a class="jxr_linenumber" name="L54" href="#L54">54</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Iterable&lt;String&gt; cppClassAllIncludes(<strong class="jxr_keyword">final</strong> Classifier classifier, <strong class="jxr_keyword">final</strong> EList&lt;Classifier&gt; list) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>      List&lt;String&gt; newList = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Classifier cl : list) {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>        <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>        <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>        <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(cl, classifier));
<a class="jxr_linenumber" name="L60" href="#L60">60</a>        <strong class="jxr_keyword">if</strong> (!_notEquals) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>          _and = false;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>        } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>          <strong class="jxr_keyword">boolean</strong> _hasStereotype = GenUtils.hasStereotype(cl, NoCodeGen.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>          <strong class="jxr_keyword">boolean</strong> _not = (!_hasStereotype);
<a class="jxr_linenumber" name="L65" href="#L65">65</a>          _and = _not;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>        }
<a class="jxr_linenumber" name="L67" href="#L67">67</a>        <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>          _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>        } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>          <strong class="jxr_keyword">boolean</strong> _hasStereotype_1 = GenUtils.hasStereotype(cl, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L71" href="#L71">71</a>          _or = _hasStereotype_1;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>        }
<a class="jxr_linenumber" name="L73" href="#L73">73</a>        <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>          <strong class="jxr_keyword">boolean</strong> _and_1 = false;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>          <strong class="jxr_keyword">boolean</strong> _and_2 = false;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>          <strong class="jxr_keyword">boolean</strong> _or_1 = false;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>          <strong class="jxr_keyword">if</strong> ((cl instanceof Enumeration)) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>            _or_1 = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>          } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>            _or_1 = (cl instanceof PrimitiveType);
<a class="jxr_linenumber" name="L81" href="#L81">81</a>          }
<a class="jxr_linenumber" name="L82" href="#L82">82</a>          <strong class="jxr_keyword">if</strong> (!_or_1) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>            _and_2 = false;
<a class="jxr_linenumber" name="L84" href="#L84">84</a>          } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>            <strong class="jxr_keyword">boolean</strong> _hasStereotype_2 = GenUtils.hasStereotype(cl, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>            <strong class="jxr_keyword">boolean</strong> _not_1 = (!_hasStereotype_2);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>            _and_2 = _not_1;
<a class="jxr_linenumber" name="L88" href="#L88">88</a>          }
<a class="jxr_linenumber" name="L89" href="#L89">89</a>          <strong class="jxr_keyword">if</strong> (!_and_2) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>            _and_1 = false;
<a class="jxr_linenumber" name="L91" href="#L91">91</a>          } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>            <strong class="jxr_keyword">boolean</strong> _hasStereotypeTree = GenUtils.hasStereotypeTree(cl, ExternLibrary.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L93" href="#L93">93</a>            <strong class="jxr_keyword">boolean</strong> _not_2 = (!_hasStereotypeTree);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>            _and_1 = _not_2;
<a class="jxr_linenumber" name="L95" href="#L95">95</a>          }
<a class="jxr_linenumber" name="L96" href="#L96">96</a>          <strong class="jxr_keyword">if</strong> (_and_1) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>            <strong class="jxr_keyword">boolean</strong> _and_3 = false;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>            Element _owner = cl.getOwner();
<a class="jxr_linenumber" name="L99" href="#L99">99</a>            <strong class="jxr_keyword">if</strong> (!(_owner instanceof org.eclipse.uml2.uml.Package)) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a>             _and_3 = false;
<a class="jxr_linenumber" name="L101" href="#L101">101</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L102" href="#L102">102</a>             Element _owner_1 = cl.getOwner();
<a class="jxr_linenumber" name="L103" href="#L103">103</a>             Element _owner_2 = classifier.getOwner();
<a class="jxr_linenumber" name="L104" href="#L104">104</a>             <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(_owner_1, _owner_2));
<a class="jxr_linenumber" name="L105" href="#L105">105</a>             _and_3 = _notEquals_1;
<a class="jxr_linenumber" name="L106" href="#L106">106</a>           }
<a class="jxr_linenumber" name="L107" href="#L107">107</a>           <strong class="jxr_keyword">if</strong> (_and_3) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a>             Element _owner_3 = cl.getOwner();
<a class="jxr_linenumber" name="L109" href="#L109">109</a>             String includePath = CppClassIncludeClassDeclaration.cppOwnerPackageIncludePath(((org.eclipse.uml2.uml.Package) _owner_3));
<a class="jxr_linenumber" name="L110" href="#L110">110</a>             <strong class="jxr_keyword">boolean</strong> _contains = newList.contains(includePath);
<a class="jxr_linenumber" name="L111" href="#L111">111</a>             <strong class="jxr_keyword">boolean</strong> _not_3 = (!_contains);
<a class="jxr_linenumber" name="L112" href="#L112">112</a>             <strong class="jxr_keyword">if</strong> (_not_3) {
<a class="jxr_linenumber" name="L113" href="#L113">113</a>               newList.add(includePath);
<a class="jxr_linenumber" name="L114" href="#L114">114</a>             }
<a class="jxr_linenumber" name="L115" href="#L115">115</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L116" href="#L116">116</a>           }
<a class="jxr_linenumber" name="L117" href="#L117">117</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L118" href="#L118">118</a>           List&lt;String&gt; _cppClassIncludes = CppClassIncludeDeclaration.cppClassIncludes(cl);
<a class="jxr_linenumber" name="L119" href="#L119">119</a>           <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> String includePath_1 : _cppClassIncludes) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a>             <strong class="jxr_keyword">boolean</strong> _contains_1 = newList.contains(includePath_1);
<a class="jxr_linenumber" name="L121" href="#L121">121</a>             <strong class="jxr_keyword">boolean</strong> _not_4 = (!_contains_1);
<a class="jxr_linenumber" name="L122" href="#L122">122</a>             <strong class="jxr_keyword">if</strong> (_not_4) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a>               newList.add(includePath_1);
<a class="jxr_linenumber" name="L124" href="#L124">124</a>             }
<a class="jxr_linenumber" name="L125" href="#L125">125</a>           }
<a class="jxr_linenumber" name="L126" href="#L126">126</a>         }
<a class="jxr_linenumber" name="L127" href="#L127">127</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L128" href="#L128">128</a>       }
<a class="jxr_linenumber" name="L129" href="#L129">129</a>     }
<a class="jxr_linenumber" name="L130" href="#L130">130</a>     <strong class="jxr_keyword">final</strong> Function1&lt;String, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;String, Boolean&gt;() {
<a class="jxr_linenumber" name="L131" href="#L131">131</a>       @Override
<a class="jxr_linenumber" name="L132" href="#L132">132</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> String str) {
<a class="jxr_linenumber" name="L133" href="#L133">133</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf((!Objects.equal(str, <strong class="jxr_keyword">null</strong>)));
<a class="jxr_linenumber" name="L134" href="#L134">134</a>       }
<a class="jxr_linenumber" name="L135" href="#L135">135</a>     };
<a class="jxr_linenumber" name="L136" href="#L136">136</a>     <strong class="jxr_keyword">return</strong> IterableExtensions.&lt;String&gt;filter(newList, _function);
<a class="jxr_linenumber" name="L137" href="#L137">137</a>   }
<a class="jxr_linenumber" name="L138" href="#L138">138</a>   
<a class="jxr_linenumber" name="L139" href="#L139">139</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Iterable&lt;String&gt; cppClassAllDeclares(<strong class="jxr_keyword">final</strong> Classifier classifier, <strong class="jxr_keyword">final</strong> EList&lt;Classifier&gt; declaredClassifiers, <strong class="jxr_keyword">final</strong> EList&lt;Classifier&gt; includedClassifiers) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a>     List&lt;String&gt; newList = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L141" href="#L141">141</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(declaredClassifiers, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L142" href="#L142">142</a>     <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a>       <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(includedClassifiers, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L144" href="#L144">144</a>       <strong class="jxr_keyword">if</strong> (_notEquals_1) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a>         declaredClassifiers.removeAll(includedClassifiers);
<a class="jxr_linenumber" name="L146" href="#L146">146</a>       }
<a class="jxr_linenumber" name="L147" href="#L147">147</a>       <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Classifier cl : declaredClassifiers) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a>         <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L149" href="#L149">149</a>         <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L150" href="#L150">150</a>         <strong class="jxr_keyword">boolean</strong> _notEquals_2 = (!Objects.equal(cl, classifier));
<a class="jxr_linenumber" name="L151" href="#L151">151</a>         <strong class="jxr_keyword">if</strong> (!_notEquals_2) {
<a class="jxr_linenumber" name="L152" href="#L152">152</a>           _and = false;
<a class="jxr_linenumber" name="L153" href="#L153">153</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L154" href="#L154">154</a>           <strong class="jxr_keyword">boolean</strong> _hasStereotype = GenUtils.hasStereotype(cl, NoCodeGen.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L155" href="#L155">155</a>           <strong class="jxr_keyword">boolean</strong> _not = (!_hasStereotype);
<a class="jxr_linenumber" name="L156" href="#L156">156</a>           _and = _not;
<a class="jxr_linenumber" name="L157" href="#L157">157</a>         }
<a class="jxr_linenumber" name="L158" href="#L158">158</a>         <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a>           _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L160" href="#L160">160</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L161" href="#L161">161</a>           <strong class="jxr_keyword">boolean</strong> _hasStereotype_1 = GenUtils.hasStereotype(cl, External.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L162" href="#L162">162</a>           _or = _hasStereotype_1;
<a class="jxr_linenumber" name="L163" href="#L163">163</a>         }
<a class="jxr_linenumber" name="L164" href="#L164">164</a>         <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L165" href="#L165">165</a>           String declaration = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L166" href="#L166">166</a>           <strong class="jxr_keyword">if</strong> (((!(cl instanceof Enumeration)) &amp;&amp; (!(cl instanceof PrimitiveType)))) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a>             <strong class="jxr_keyword">if</strong> ((cl instanceof DataType)) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a>               String _openNSMinimal = CppGenUtils.openNSMinimal(cl);
<a class="jxr_linenumber" name="L169" href="#L169">169</a>               String _plus = (_openNSMinimal + <span class="jxr_string">"struct "</span>);
<a class="jxr_linenumber" name="L170" href="#L170">170</a>               String _name = ((DataType)cl).getName();
<a class="jxr_linenumber" name="L171" href="#L171">171</a>               String _plus_1 = (_plus + _name);
<a class="jxr_linenumber" name="L172" href="#L172">172</a>               String _plus_2 = (_plus_1 + <span class="jxr_string">";"</span>);
<a class="jxr_linenumber" name="L173" href="#L173">173</a>               String _closeNSMinimal = CppGenUtils.closeNSMinimal(cl);
<a class="jxr_linenumber" name="L174" href="#L174">174</a>               String _plus_3 = (_plus_2 + _closeNSMinimal);
<a class="jxr_linenumber" name="L175" href="#L175">175</a>               declaration = _plus_3;
<a class="jxr_linenumber" name="L176" href="#L176">176</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L177" href="#L177">177</a>               String _openNSMinimal_1 = CppGenUtils.openNSMinimal(cl);
<a class="jxr_linenumber" name="L178" href="#L178">178</a>               String _replaceAll = _openNSMinimal_1.replaceAll(<span class="jxr_string">"\r"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L179" href="#L179">179</a>               String _replaceAll_1 = _replaceAll.replaceAll(<span class="jxr_string">"\n"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L180" href="#L180">180</a>               String _plus_4 = (_replaceAll_1 + <span class="jxr_string">"class "</span>);
<a class="jxr_linenumber" name="L181" href="#L181">181</a>               String _name_1 = cl.getName();
<a class="jxr_linenumber" name="L182" href="#L182">182</a>               String _plus_5 = (_plus_4 + _name_1);
<a class="jxr_linenumber" name="L183" href="#L183">183</a>               String _plus_6 = (_plus_5 + <span class="jxr_string">";"</span>);
<a class="jxr_linenumber" name="L184" href="#L184">184</a>               String _closeNSMinimal_1 = CppGenUtils.closeNSMinimal(cl);
<a class="jxr_linenumber" name="L185" href="#L185">185</a>               String _replaceAll_2 = _closeNSMinimal_1.replaceAll(<span class="jxr_string">"\r"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L186" href="#L186">186</a>               String _replaceAll_3 = _replaceAll_2.replaceAll(<span class="jxr_string">"\n"</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L187" href="#L187">187</a>               String _plus_7 = (_plus_6 + _replaceAll_3);
<a class="jxr_linenumber" name="L188" href="#L188">188</a>               declaration = _plus_7;
<a class="jxr_linenumber" name="L189" href="#L189">189</a>             }
<a class="jxr_linenumber" name="L190" href="#L190">190</a>           }
<a class="jxr_linenumber" name="L191" href="#L191">191</a>           <strong class="jxr_keyword">boolean</strong> _notEquals_3 = (!Objects.equal(declaration, <span class="jxr_string">""</span>));
<a class="jxr_linenumber" name="L192" href="#L192">192</a>           <strong class="jxr_keyword">if</strong> (_notEquals_3) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a>             <strong class="jxr_keyword">boolean</strong> _contains = newList.contains(declaration);
<a class="jxr_linenumber" name="L194" href="#L194">194</a>             <strong class="jxr_keyword">boolean</strong> _not_1 = (!_contains);
<a class="jxr_linenumber" name="L195" href="#L195">195</a>             <strong class="jxr_keyword">if</strong> (_not_1) {
<a class="jxr_linenumber" name="L196" href="#L196">196</a>               newList.add(declaration);
<a class="jxr_linenumber" name="L197" href="#L197">197</a>             }
<a class="jxr_linenumber" name="L198" href="#L198">198</a>           }
<a class="jxr_linenumber" name="L199" href="#L199">199</a>         }
<a class="jxr_linenumber" name="L200" href="#L200">200</a>       }
<a class="jxr_linenumber" name="L201" href="#L201">201</a>     }
<a class="jxr_linenumber" name="L202" href="#L202">202</a>     <strong class="jxr_keyword">final</strong> Function1&lt;String, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;String, Boolean&gt;() {
<a class="jxr_linenumber" name="L203" href="#L203">203</a>       @Override
<a class="jxr_linenumber" name="L204" href="#L204">204</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> String str) {
<a class="jxr_linenumber" name="L205" href="#L205">205</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf((!Objects.equal(str, <strong class="jxr_keyword">null</strong>)));
<a class="jxr_linenumber" name="L206" href="#L206">206</a>       }
<a class="jxr_linenumber" name="L207" href="#L207">207</a>     };
<a class="jxr_linenumber" name="L208" href="#L208">208</a>     <strong class="jxr_keyword">return</strong> IterableExtensions.&lt;String&gt;filter(newList, _function);
<a class="jxr_linenumber" name="L209" href="#L209">209</a>   }
<a class="jxr_linenumber" name="L210" href="#L210">210</a>   
<a class="jxr_linenumber" name="L211" href="#L211">211</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Iterable&lt;String&gt; CppClassAllIncludes(<strong class="jxr_keyword">final</strong> Classifier clazz) {
<a class="jxr_linenumber" name="L212" href="#L212">212</a>     EList&lt;Classifier&gt; _includedClassifiers = CppClassUtils.includedClassifiers(clazz);
<a class="jxr_linenumber" name="L213" href="#L213">213</a>     <strong class="jxr_keyword">return</strong> CppClassIncludeClassDeclaration.cppClassAllIncludes(clazz, _includedClassifiers);
<a class="jxr_linenumber" name="L214" href="#L214">214</a>   }
<a class="jxr_linenumber" name="L215" href="#L215">215</a>   
<a class="jxr_linenumber" name="L216" href="#L216">216</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Iterable&lt;String&gt; CppClassAllDeclares(<strong class="jxr_keyword">final</strong> Classifier clazz) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a>     EList&lt;Classifier&gt; _declaredClassifiers = CppClassUtils.declaredClassifiers(clazz);
<a class="jxr_linenumber" name="L218" href="#L218">218</a>     EList&lt;Classifier&gt; _includedClassifiers = CppClassUtils.includedClassifiers(clazz);
<a class="jxr_linenumber" name="L219" href="#L219">219</a>     <strong class="jxr_keyword">return</strong> CppClassIncludeClassDeclaration.cppClassAllDeclares(clazz, _declaredClassifiers, _includedClassifiers);
<a class="jxr_linenumber" name="L220" href="#L220">220</a>   }
<a class="jxr_linenumber" name="L221" href="#L221">221</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
